package de.hft.stuttgart.citydoctor2.webservice.endpoints;

import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

public class TestUtils {

	private TestUtils() {
		// only static use
	}

	public static LoginValues login(HttpClient client) throws ClientProtocolException, IOException {
		HttpPost post = new HttpPost("http://localhost:8080/CityDoctorWebService/rest/login");

		List<NameValuePair> params = new ArrayList<>(2);
		params.add(new BasicNameValuePair("username", "Test"));
		params.add(new BasicNameValuePair("password", "TestPassword"));
		post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));

		HttpResponse response = client.execute(post);
		String text = readCompleteReponse(response);
		try {
			JSONTokener tokener = new JSONTokener(text);
			JSONObject o = new JSONObject(tokener);
			String token = o.getString("token");
			int id = o.getInt("userId");
			return new LoginValues(token, id);
		} catch (JSONException e) {
			System.out.println(text);
			throw e;
		}
	}

	public static String readCompleteReponse(HttpResponse response) throws IOException {
		InputStreamReader reader = new InputStreamReader(response.getEntity().getContent());
		char[] buffer = new char[1000];
		int readChars = -1;
		StringBuilder sb = new StringBuilder();
		while ((readChars = reader.read(buffer)) != -1) {
			sb.append(buffer, 0, readChars);
		}
		return sb.toString();
	}

	public static JSONTokener tokenizeReponse(HttpResponse response) throws IOException {
		return new JSONTokener(readCompleteReponse(response));
	}

}
